/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.java.net
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.ui.impl;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.swing.JComponent;
import org.openide.util.Utilities;
import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.netbeans.windows.role.GuiBuilder;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ServiceProvider(service=IntegrityCheckerViewBuilder.class)
public class IntegrityCheckerViewBuilder implements GuiBuilder
  {
    @CheckForNull
    private JComponent view;
    
    @Override @Nonnull
    public synchronized JComponent createGui() 
      {
        if (view == null)
          {
            view = Utilities.isMac() ? new MacOSXIntegrityCheckerViewPanel() : new DefaultIntegrityCheckerViewPanel();
          }
        
        return view;
      }
  }
