/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.java.net
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.ui.impl.action;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.NotThreadSafe;
import it.tidalwave.netbeans.action.ActionProxy;
import it.tidalwave.actor.CollaborationCompletedMessage;
import it.tidalwave.actor.CollaborationStartedMessage;
import it.tidalwave.actor.annotation.Actor;
import it.tidalwave.actor.annotation.CollaborationListener;
import it.tidalwave.integritychecker.FileScanRequestMessage;
import it.tidalwave.integritychecker.ui.IntegrityCheckerViewController;
import lombok.extern.slf4j.Slf4j;

/***********************************************************************************************************************
 * 
 * @stereotype Actor
 * @stereotype Controller
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Actor(threadSafe=false) @NotThreadSafe @Slf4j
public class ScanActionEnablerActor implements IntegrityCheckerViewController
  {
    private final ActionProxy actionProxy = new ActionProxy(ScanAction.class);
//    private final ActionProxy actionProxy = new ActionProxy("File", "it-tidalwave-integritychecker-ui-impl-action-ScanAction");
    
    @CollaborationListener(message=FileScanRequestMessage.class)
    public void scanStarted (final @Nonnull CollaborationStartedMessage message)
      {
        actionProxy.setEnabled(false);
      }
    
    @CollaborationListener(message=FileScanRequestMessage.class)
    public void scanCompleted (final @Nonnull CollaborationCompletedMessage message)
      {
        actionProxy.setEnabled(true);
      }
  }
