/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.java.net
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.action;

import javax.annotation.Nonnull;
import java.io.File;
import java.awt.event.ActionEvent;
import org.openide.util.HelpCtx;
import org.openide.util.actions.SystemAction;
import it.tidalwave.actor.MessageSupport;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class FileSelectionMessageSenderAction extends SystemAction 
  {
    @Override
    public void actionPerformed (final @Nonnull ActionEvent event) 
      {
        final FileChooser fileChooser = new FileChooser() 
          {
            @Override
            protected void onFileSelected (final @Nonnull File folder) 
              {
                createMessage(folder).send();
              }
          };
        
        fileChooser.run(event);
      }

    @Nonnull
    protected abstract MessageSupport createMessage (final @Nonnull File file);

    @Override
    public String getName() 
      {
        return "---";
      }

    @Override
    public HelpCtx getHelpCtx() 
      {
        return null;
      }
  }
